unit ufrmMainLibrary;

interface

uses
  Windows
  , Messages
  , SysUtils
  , Classes
  , Graphics
  , Controls
  , Forms
  , Dialogs
  , uToyLibrary
  , StdCtrls, ExtCtrls
  ;

type
  TfrmMainLibrary = class(TForm)
    lstToys: TListBox;
    cmdSet1: TButton;
    cmdSet2: TButton;
    cmdSet3: TButton;
    cmdPlay: TButton;
    cmdTidy: TButton;
    cmdGive: TButton;
    rgrpToyTypes: TRadioGroup;
    cmdClose: TButton;
    procedure cmdSet1Click(Sender: TObject);
    procedure cmdSet2Click(Sender: TObject);
    procedure cmdSet3Click(Sender: TObject);
    procedure cmdPlayClick(Sender: TObject);
    procedure cmdTidyClick(Sender: TObject);
    procedure cmdGiveClick(Sender: TObject);
    procedure rgrpToyTypesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
  private
    { Private declarations }
    FLibrary: TToyLibrary;
    FToyType: integer;

  public
    { Public declarations }
  end;

var
  frmMainLibrary: TfrmMainLibrary;

implementation

uses
  uToy
  , uBricksFactory
  , uDollsFactory
  ;

{$R *.DFM}

procedure TfrmMainLibrary.cmdSet1Click(Sender: TObject);
var
  nItem: integer;
  sToyType: string;
begin
  // Get set no. 1
  if Assigned(FLibrary) and
     (rgrpToyTypes.ItemIndex > -1) then
  begin
    sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
    nItem := lstToys.Items.AddObject('', FLibrary.GetSet1(sToyType));
    lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
  end;
end;

procedure TfrmMainLibrary.cmdSet2Click(Sender: TObject);
var
  nItem: integer;
  sToyType: string;
begin
  // Get set no. 2
  if Assigned(FLibrary) and
     (rgrpToyTypes.ItemIndex > -1) then
  begin
    sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
    nItem := lstToys.Items.AddObject('', FLibrary.GetSet2(sToyType));
    lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
  end;
end;

procedure TfrmMainLibrary.cmdSet3Click(Sender: TObject);
var
  nItem: integer;
  sToyType: string;
begin
  // Get set no. 3
  if Assigned(FLibrary) and
     (rgrpToyTypes.ItemIndex > -1) then
  begin
    sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
    nItem := lstToys.Items.AddObject('', FLibrary.GetSet3(sToyType));
    lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
  end;
end;

procedure TfrmMainLibrary.cmdPlayClick(Sender: TObject);
begin
  // Play with the selected toy set
  if (lstToys.ItemIndex > -1) then
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).PlayWithMe;
end;

procedure TfrmMainLibrary.cmdTidyClick(Sender: TObject);
begin
  // Tidy the selected toy set away
  if (lstToys.ItemIndex > -1) then
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).TidyMeAway;
end;

procedure TfrmMainLibrary.cmdGiveClick(Sender: TObject);
var
  sToyType: string;
begin
  // Return the selected toy set to the library
  if (lstToys.ItemIndex > -1) then
  begin
    if Assigned(FLibrary) and
       (rgrpToyTypes.ItemIndex > -1) then
    begin
      sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
      FLibrary.Return(TToy(lstToys.Items.Objects[lstToys.ItemIndex]), sToyType);
    end;
    lstToys.Items.Delete(lstToys.ItemIndex);
  end;
end;

procedure TfrmMainLibrary.rgrpToyTypesClick(Sender: TObject);
begin
  try
    if (FToyType <> rgrpToyTypes.ItemIndex) and
       (lstToys.Items.Count = 0) then
      FToyType := rgrpToyTypes.ItemIndex
    else
      raise Exception.Create('You must give away all your toys before you can have one of a different type');
  except
    rgrpToyTypes.ItemIndex := FToyType;
    raise;
  end;
end;

procedure TfrmMainLibrary.FormCreate(Sender: TObject);
var
  slToyTypes: TStringList;
begin
  FToyType := -1;
  // Create a toy library and load the "catalogue" into the toy types radio group
  FLibrary := TToyLibrary.Create;
  rgrpToyTypes.Items.Clear;
  FLibrary.GetToyTypes(rgrpToyTypes.Items);
end;

procedure TfrmMainLibrary.cmdCloseClick(Sender: TObject);
begin
  Self.Close;
end;

end.
